g = golly()

function IsolateOneOscillator()
	--change rule to isolate
	g.setrule("isolate")
	--change a random state 1 cell to state 4
	local cells = g.getcells(g.getrect())
	--find a state 1 cell
	local found = false
	local todo
	for i = 1,#cells,3 do
		if cells[i+2] == 1 then
			found = true
			todo = i
			break;
		end
	end
	if found then
		g.setcell(cells[todo],cells[todo+1],4)
	else
		g.show("None found")
	end
	--run for 500 gens
	g.run(500)
	--copy entire pattern into layer 2
	local layer2 = g.duplicate()
	--remove all state 3,4,5 cells from layer 1
	g.setlayer(0)
	g.setrule("remove345")
	g.step()
	g.setrule("greycells")
	--remove all state 1,2 cells from layer 2
	g.setlayer(1)
	g.setrule("remove12")
	g.step()
	g.setrule("convert")
	g.step()
	g.setrule("greycells")
	--an oscillator has now been moved from layer 1 to layer 2
end

function FindItsPeriod()
	g.setlayer(1)
	--oscar, not doing that yet lol
	local pppppppppp = 0

-- initialize lists
local hashlist = {}     -- for pattern hash values
local genlist = {}      -- corresponding generation counts
local poplist = {}      -- corresponding population counts
local boxlist = {}      -- corresponding bounding boxes

----------------------------------------------------------------------

local function oscillating()
    -- return true if the pattern is empty, stable or oscillating
    
    -- first get current pattern's bounding box
    local pbox = g.getrect()
    if #pbox == 0 then
        g.show("The pattern is empty.")
        return true
    end
    
    local h = g.hash(pbox)
    
    -- determine where to insert h into hashlist
    local pos = 1
    local listlen = #hashlist
    while pos <= listlen do
        if h > hashlist[pos] then
            pos = pos + 1
        elseif h < hashlist[pos] then
            -- shorten lists and append info below
            for i = 1, listlen - pos + 1 do
                table.remove(hashlist)
                table.remove(genlist)
                table.remove(poplist)
                table.remove(boxlist)
            end
            break
        else
            -- h == hashlist[pos] so pattern is probably oscillating, but just in
            -- case this is a hash collision we also compare pop count and box size
            local rect = boxlist[pos]
            if tonumber(g.getpop()) == poplist[pos] and pbox[3] == rect[3] and pbox[4] == rect[4] then
                local period = tonumber(g.getgen()) - genlist[pos]
                
                if hasB0notS8 and (period % 2) > 0 and
                   pbox[1] == rect[1] and pbox[2] == rect[2] and
                   pbox[3] == rect[3] and pbox[4] == rect[4] then
                    -- ignore this hash value because B0-and-not-S8 rules are
                    -- emulated by using different rules for odd and even gens,
                    -- so it's possible to have identical patterns at gen G and
                    -- gen G+p if p is odd
                    return false
                end
                
                if period == 1 then
                    if pbox[1] == rect[1] and pbox[2] == rect[2] and
                       pbox[3] == rect[3] and pbox[4] == rect[4] then
                        g.show("The pattern is stable.")
                    else
                        --show_spaceship_speed(1, 0, 0)
                    end
                elseif pbox[1] == rect[1] and pbox[2] == rect[2] and
                       pbox[3] == rect[3] and pbox[4] == rect[4] then
               		 pppppppppp = period
                else
                    local deltax = math.abs(rect[1] - pbox[1])
                    local deltay = math.abs(rect[2] - pbox[2])
                    --show_spaceship_speed(period, deltax, deltay)
                end
                return true
            else
                -- look at next matching hash value or insert if no more
                pos = pos + 1
            end
        end
    end
    
    -- store hash/gen/pop/box info at same position in various lists
    table.insert(hashlist, pos, h)
    table.insert(genlist, pos, tonumber(g.getgen()))
    table.insert(poplist, pos, tonumber(g.getpop()))
    table.insert(boxlist, pos, pbox)
    
    return false
end

g.show("Finding period... (hit escape to abort)")

local oldsecs = os.clock()
while not oscillating() do
    g.run(1)
    local newsecs = os.clock()
    if newsecs - oldsecs >= 1.0 then   -- show pattern every second
        oldsecs = newsecs
        --g.update()
    end
end
	return pppppppppp
end

function SaveIt(Period)
	if Period > 17 then
		--it's interesting, so save it
		--standardise name
		local minpop = tonumber(g.getpop())
		for i = 1,Period do
			g.step()
			if minpop > tonumber(g.getpop()) then
				minpop = tonumber(g.getpop())
			end
		end
		local Name = tostring(Period).." - "..tostring(minpop).." - "..tostring(os.clock())
		--save
		if Period > 100 then
			g.save("/BIG/"..Name..".rle","rle")
		else
			g.save("/"..tostring(Period).."/"..Name..".rle","rle")
		end
	else
		--it's not interesting, don't waste space on it
	end
	g.select(g.getrect())
	g.clear(0)
	g.dellayer()
	g.setlayer(0)
	g.setrule("greycells")
end

function process()
	g.setbase(2)
	g.setstep(0)
	local ThereAreOscillators = not g.empty()
	g.setrule("convert")
	g.step()
	g.setrule("greycells")
	while ThereAreOscillators do
		IsolateOneOscillator()
		local Period = FindItsPeriod()
		SaveIt(Period)
		ThereAreOscillators = not g.empty()
	end
	g.show("Done")
end

g.show("Going")
process()